﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace LovciPokladu
{
    public partial class Form1 : Form
    {
        WebClient client = new WebClient();

        Hra hra = null;

        public static string server = "http://localhost:8000";

        int xOff = 30; // offset
        int yOff = 30; // offset

        int width = 40;
        int height = 40;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            Graphics graphics = e.Graphics;

            // Kreslení
            if(hra != null && !hra.Konec)
            {
                for(int x = 0; x < hra.hraciPole.GetLength(0); x++)
                {
                    for(int y = 0; y < hra.hraciPole.GetLength(1); y++)
                    {
                        if(hra.hraciPole[x, y] == "XX") // zed
                            graphics.FillRectangle(Brushes.Black, xOff + x * width, yOff + y * height, width, height);
                        else if(hra.hraciPole[x, y] == "++") // zakladna
                            graphics.FillRectangle(Brushes.Green, xOff + x * width, yOff + y * height, width, height);
                        else if(hra.hraciPole[x, y] == "--") // zakladna
                            graphics.FillRectangle(Brushes.Red, xOff + x * width, yOff + y * height, width, height);
                        else if(hra.hraciPole[x, y] != "..") // jummy... 
                        {
                            graphics.FillRectangle(Brushes.Yellow, xOff + x * width, yOff + y * height, width, height);
                            graphics.DrawString(hra.hraciPole[x, y], new Font("Arial", 16.0f), Brushes.Magenta, xOff + x * width, yOff + y * height);
                        }

                        // hrac1
                        Hrac hrac1 = hra.hrac1;
                        Hrac hrac2 = hra.hrac2;

                        graphics.FillRectangle(Brushes.LimeGreen, xOff + (hrac1.pozice.X - 1) * width, yOff + (hrac1.pozice.Y - 1) * height, width, height);
                        graphics.DrawString("H1", new Font("Arial", 16.0f), Brushes.Magenta, xOff + (hrac1.pozice.X - 1) * width, yOff + (hrac1.pozice.Y - 1) * height);

                        // hrac2
                        if(hra.hrac2 != null)
                        {
                            graphics.FillRectangle(Brushes.Aquamarine, xOff + (hrac2.pozice.X - 1) * width, yOff + (hrac2.pozice.Y - 1) * height, width, height);
                            graphics.DrawString("H2", new Font("Arial", 16.0f), Brushes.Magenta, xOff + (hrac2.pozice.X - 1) * width, yOff + (hrac2.pozice.Y - 1) * height);
                        }
                    }
                }
            }
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            if(hra.Konec || hra.gameType != Hra.GameType.Interactive)
                return;

            switch(e.KeyCode)
            {
                case Keys.L: // levo
                case Keys.Left:
                    {
                        hra.Tah("L");
                    }
                    break;

                case Keys.P: // pravo
                case Keys.Right:
                    {
                        hra.Tah("P");
                    }
                    break;

                case Keys.N: // nahoru
                case Keys.Up:
                    {
                        hra.Tah("N");
                    }
                    break;

                case Keys.D: // dolu
                case Keys.Down:
                    {
                        hra.Tah("D");
                    }
                    break;
            }

            if(hra.gameType != Hra.GameType.AI_1Player || hra.gameType == Hra.GameType.Interactive)
                hra.player1Play = !hra.player1Play;

            showInfoLabel();
        }

        private void serverToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string input = Microsoft.VisualBasic.Interaction.InputBox("Zadejte server URL",
                                               "SERVER URL",
                                               server,
                                               -1, -1);

            if(input != null && input != "")
                server = input;
        }

        void showInfoLabel()
        {
            if(hra == null)
                return;

            Hrac hrac = hra.hrac1;

            infoLabel.Text = "Právě nese: " + hrac.poklad + "\n"
                           + "Celkově: " + hrac.celkove + "\n"
                           + "Pocet tahu:" + (hra.tahyLeft - hra.tahy).ToString() + "\n"
                           + "Celkove tahu: " + hra.tahyLeft.ToString();

            hrac = hra.hrac2;

            if(hrac != null)
            {
                infoLabel2.Text = "Právě nese: " + hrac.poklad + "\n"
                                + "Celkově: " + hrac.celkove + "\n"
                                + "Pocet tahu:" + (hra.tahyLeft - hra.tahy).ToString() + "\n"
                                + "Celkove tahu: " + hra.tahyLeft.ToString();
            }
        }

        private void timerRepaint_Tick(object sender, EventArgs e)
        {
            Invalidate();
        }

        // Interaktivní hra
        private void hráčToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string start = client.DownloadString(server + "/start");

            // Creating
            hra = new Hra()
            {
                client = client,
                gameType = Hra.GameType.Interactive
            };

            hra.Parse(start, true);

            showInfoLabel();
        }

        // AI 1 hráč
        private void jedenHráčToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string start = client.DownloadString(server + "/start");

            // Creating
            hra = new Hra()
            {
                client = client,
                gameType = Hra.GameType.AI_1Player
            };

            hra.Parse(start, true);

            showInfoLabel();

            AITimer.Start();
        }

        private void AITimer_Tick(object sender, EventArgs e)
        {
            if(hra == null || (hra != null && hra.Konec))
                return;

            Point pozice = new Point(hra.hrac1.pozice.X - 1, hra.hrac1.pozice.Y - 1);

            if(hra.hrac1.poklad < 1)
            {
                hra.solveGame(pozice.X, pozice.Y); // startovní pozice

                if(hra.solutionFound)
                {
                    bool none = false;

                    if(pozice.X != 0 && hra.solution[pozice.X - 1, pozice.Y])
                    {
                        none = true;
                        hra.solution[pozice.X - 1, pozice.Y] = false;

                        hra.Tah("L");
                    }
                    if(pozice.X != 10 - 1 && hra.solution[pozice.X + 1, pozice.Y])
                    {
                        none = true;
                        hra.solution[pozice.X + 1, pozice.Y] = false;

                        hra.Tah("P");
                    }
                    if(pozice.Y != 0 && hra.solution[pozice.X, pozice.Y - 1])
                    {
                        none = true;
                        hra.solution[pozice.X, pozice.Y - 1] = false;

                        hra.Tah("N");
                    }
                    if(pozice.Y != 10 - 1 && hra.solution[pozice.X, pozice.Y + 1])
                    {
                        none = true;
                        hra.solution[pozice.X, pozice.Y + 1] = false;

                        hra.Tah("D");
                    }

                    if(!none && hra.topPoklady.ContainsKey(new Point(pozice.X, pozice.Y - 1)))
                        hra.Tah("N");
                    else if(!none && hra.topPoklady.ContainsKey(new Point(pozice.X, pozice.Y + 1)))
                        hra.Tah("D");
                    else if(!none && hra.topPoklady.ContainsKey(new Point(pozice.X - 1, pozice.Y)))
                        hra.Tah("L");
                    else if(!none && hra.topPoklady.ContainsKey(new Point(pozice.X + 1, pozice.Y)))
                        hra.Tah("P");
                }
            }
            else
            {
                if(hra.topPoklady.ContainsKey(new Point(pozice.X, pozice.Y)))
                    hra.topPoklady.Remove(new Point(pozice.X, pozice.Y));

                hra.solveGame(pozice.X, pozice.Y, true);

                if(hra.solutionFound)
                {
                    if(pozice.X != 0 && hra.solution[pozice.X - 1, pozice.Y])
                    {
                        hra.solution[pozice.X - 1, pozice.Y] = false;

                        hra.Tah("L");
                    }
                    if(pozice.X != 10 - 1 && hra.solution[pozice.X + 1, pozice.Y])
                    {
                        hra.solution[pozice.X + 1, pozice.Y] = false;

                        hra.Tah("P");
                    }
                    if(pozice.Y != 0 && hra.solution[pozice.X, pozice.Y - 1])
                    {
                        hra.solution[pozice.X, pozice.Y - 1] = false;

                        hra.Tah("N");
                    }
                    if(pozice.Y != 10 - 1 && hra.solution[pozice.X, pozice.Y + 1])
                    {
                        hra.solution[pozice.X, pozice.Y + 1] = false;

                        hra.Tah("D");
                    }

                    // repair :: something goes wrong ://
                    if(pozice.X - 1 == hra.hrac1.zakladna.X && pozice.Y == hra.hrac1.zakladna.Y)
                        hra.Tah("L");
                    if(pozice.X + 1 == hra.hrac1.zakladna.X && pozice.Y == hra.hrac1.zakladna.Y)
                        hra.Tah("P");
                    if(pozice.X == hra.hrac1.zakladna.X && pozice.Y - 1 == hra.hrac1.zakladna.Y)
                        hra.Tah("N");
                    if(pozice.X == hra.hrac1.zakladna.X && pozice.Y + 1 == hra.hrac1.zakladna.Y)
                        hra.Tah("D");
                }
            }

            if(pozice == hra.hrac1.zakladna && hra.topPoklady.Count == 0)
            {
                AITimer.Stop();

                MessageBox.Show(String.Format("Konec hry: {0} {1}", hra.hrac1.celkove, hra.hrac2 != null ? hra.hrac2.celkove.ToString() : ""));
            }

            Invalidate();

            showInfoLabel();
        }
    }
}
