﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace LovciPokladu
{
    /*
     1 - ID
    100 - tahy
    XXXXXXXXXXXXXXXXXXXX - 0
    .................... - 1
    XX..XXXXXXXX........ - 2
    ..........XX........ - 3
    XXXXXXXX..XX........ - 4
    ..........XX......99 - 5 
    XX..XXXXXXXXXXXXXXXX - 6 
    ..............101010 - 7
    XXXXXXXX..XX..101010 - 8 
    ++........XX..101099 - 9
    1 10 0 0 - first player
    - second player

     */

    class Hra
    {
        public int ID;
        public WebClient client;

        public int tahy;
        public int tahyLeft;

        public Hrac hrac1;
        public Hrac hrac2;

        public string[,] hraciPole;

        public Dictionary<Point, string> topPoklady = new Dictionary<Point, string>();

        /*
         *  - .. => volne pole
         * 1 - XX => zed
         * 
         */

        public bool Konec = false;

        public enum GameType
        {
            Interactive,
            AI_1Player
        }

        public GameType gameType;

        public bool player1Play = true;

        public Hra()
        {

        }

        public void Tah(string key)
        {
            string response = client.DownloadString(String.Format("{0}/tah?id={1}&pohyb={2}", Form1.server, ID, key));
            
            if(response.StartsWith("Konec hry:") || response.StartsWith("Chyba:"))
            {
                Konec = true;

                if(response.StartsWith("Konec hry:"))
                    MessageBox.Show(String.Format("Konec hry: {0} {1}", hrac1.celkove, hrac2 != null ? hrac2.celkove.ToString() : ""));
                else
                    MessageBox.Show(response);
            }
            else // pokračuj
                Parse(response);
        }

        public void Parse(string data, bool start = false)
        {
            string[] split = data.Split(new string[] { "\r\n" }, StringSplitOptions.None);

            int id   = 0;
            int tahy = 0;

            Hrac hrac1 = null;
            Hrac hrac2 = null;

            Point zakladna1 = new Point();
            Point zakladna2 = new Point();

            string[,] pole = new string[10, 10];

            topPoklady.Clear();

            // Parsing...
            for(int i = 0; i < split.Length; i++)
            {
                string line = split[i];

                if(i == 0)
                    id = Int32.Parse(line);
                else if(i == 1)
                    tahy = Int32.Parse(line);
                else if(i > 1 && i < 12)
                {
                    for(int j = 0; j < line.Length; j += 2)
                    {
                        char znak1 = line[j];
                        char znak2 = line[j + 1];

                        string policko = String.Format("{0}{1}", znak1, znak2);

                        pole[j / 2, i - 2] = policko;

                        if(policko == "++")
                            zakladna1 = new Point(j / 2, i - 2);
                        else if(policko == "--")
                            zakladna2 = new Point(j / 2, i - 2);

                        if(policko != "++" && policko != "--" && policko != ".." && policko != "XX")
                            topPoklady[new Point(j / 2, i - 2)] = policko;
                    }
                }
                else if(i == 12)
                {
                    string[] split2 = line.Split(' ');

                    int S = Int32.Parse(split2[0]); // sloupec
                    int R = Int32.Parse(split2[1]); // radek
                    int P = Int32.Parse(split2[2]); // poklad lovce, 0 = nenese, X = nese v dane hodnote
                    int C = Int32.Parse(split2[3]); // celkova hodnota pokladu co prinesl uz

                    hrac1 = new Hrac()
                    {
                        pozice = new Point(S, R),
                        zakladna = zakladna1,
                        poklad = P,
                        celkove = C
                    };
                }
                else if(i == 13 && line != "")
                {
                    string[] split2 = line.Split(' ');

                    int S = Int32.Parse(split2[0]); // sloupec
                    int R = Int32.Parse(split2[1]); // radek
                    int P = Int32.Parse(split2[2]); // poklad lovce, 0 = nenese, X = nese v dane hodnote
                    int C = Int32.Parse(split2[3]); // celkova hodnota pokladu co prinesl uz

                    hrac2 = new Hrac()
                    {
                        pozice = new Point(S, R),
                        zakladna = zakladna2,
                        poklad = P,
                        celkove = C
                    };
                }
            }

            ID = id;
            this.tahy = tahy;
            hraciPole = pole;
            this.hrac1 = hrac1;
            this.hrac2 = hrac2;

            if(start)
                this.tahyLeft = tahy;
        }

        public bool[,] solution = new bool[10, 10];
        bool[,] wasHere = new bool[10, 10];

        public bool solutionFound = false;

        Point end = new Point(0, 0);

        public void solveGame(int targetX, int targetY, bool zakladna = false)
        {
            if(((topPoklady.Count < 1 && end == hrac1.pozice) && hrac1.poklad == 0 && !zakladna))
                return;

            // top poklad
            if(!zakladna)
            {
                if(topPoklady.Count > 0)
                {
                    for(int x = 0; x < 10; x++)
                    {
                        bool found = false;

                        for(int y = 0; y < 10; y++)
                        {
                            if(topPoklady.ContainsKey(new Point(x, y)) && hraciPole[x, y] == topPoklady[new Point(x, y)])
                            {
                                end = new Point(x, y);

                                found = true;

                                break;
                            }
                        }

                        if(found)
                            break;
                    }
                }
            }
            else
                end = new Point(hrac1.zakladna.X, hrac1.zakladna.Y);

            for(int x = 0; x < 10; x++)
            {
                for(int y = 0; y < 10; y++)
                    wasHere[x, y] = solution[x, y] = false;
            }

            solutionFound = recursiveSolve(targetX, targetY, zakladna); // hrac pozice
        }

        public bool recursiveSolve(int Sx, int Sy, bool zakladna)
        {
            if(Sx == end.X && Sy == end.Y)
                return true;

            if(hraciPole[Sx, Sy] == "--" || hraciPole[Sx, Sy] == "XX" || wasHere[Sx, Sy])
                return false;

            if(hrac1.poklad > 0 && !zakladna)
                return false;

            wasHere[Sx, Sy] = true;

            if(Sx != 0)  // Checks if not on left edge
            {
                if(recursiveSolve(Sx - 1, Sy, zakladna))
                {
                    solution[Sx, Sy] = true;
                    return true;
                }
            }
            if(Sx != 10 - 1) // Checks if not on right edge
            {
                if(recursiveSolve(Sx + 1, Sy, zakladna))
                { // Recalls method one to the right
                    solution[Sx, Sy] = true;
                    return true;
                }
            }
            if(Sy != 0)  // Checks if not on top edge
            {
                if(recursiveSolve(Sx, Sy - 1, zakladna))
                { // Recalls method one up
                    solution[Sx, Sy] = true;
                    return true;
                }
            }
            if(Sy != 10 - 1) // Checks if not on bottom edge
            {
                if(recursiveSolve(Sx, Sy + 1, zakladna))
                { // Recalls method one down
                    solution[Sx, Sy] = true;
                    return true;
                }
            }

            return false;
        }
    }

    class Hrac
    {
        public Point pozice;
        public Point zakladna;
        public int poklad;
        public int celkove;
    }
}
